Index: /java/main/src/main/java/com/framsticks/model/F0Model.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/F0Model.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/model/F0Model.java	(revision 78)
@@ -0,0 +1,59 @@
+package com.framsticks.model;
+
+import com.framsticks.params.FramsClass;
+import com.framsticks.util.Orientation;
+
+import java.util.ArrayList;
+import java.util.List;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class F0Model {
+
+	public final List<MechPart> mechparts = new ArrayList<MechPart>();
+	public final List<MechJoint> mechjoints = new ArrayList<MechJoint>();
+	public final List<Neuro> neurons = new ArrayList<Neuro>();
+
+	public final List<MechPart> getMechParts() { return mechparts; }
+	public final List<MechJoint> getMechJoints() { return mechjoints; }
+	public final List<Neuro> getNeurons() { return neurons; }
+
+	public static void constructFramsClass(FramsClass.Constructor constructor) {
+		constructor.field("mechparts");
+		constructor.field("mechjoints");
+		constructor.field("neurons");
+	}
+
+	public static F0Model build(F0Genotype f0Genotype) {
+		F0Model model = new F0Model();
+
+		for (Part p : f0Genotype.getParts()) {
+			/** based on c++ Model::build*/
+			MechPart mp = new MechPart();
+			mp.setPosition(p.getPosition());
+			mp.setOrientation(new Orientation().rotate(p.getRotation()));
+			mp.copyFrom(p);
+			model.mechparts.add(mp);
+		}
+		for (Joint j : f0Genotype.getJoints()) {
+			/** based on c++ Joint::attachToParts*/
+			MechPart mp1 = model.mechparts.get(j.getP1());
+			MechPart mp2 = model.mechparts.get(j.getP2());
+			assert mp1 != null && mp2 != null;
+			MechJoint mj = new MechJoint();
+			mj.copyFrom(j);
+			Orientation o = new Orientation().rotate(j.getRotation());
+			mp2.setOrientation(mp1.getOrientation().transform(o));
+			mp2.setPosition(mp2.getOrientation().transform(j.getDelta()).add(mp1.getPosition()));
+			model.mechjoints.add(mj);
+		}
+		for (NeuroDef nd : f0Genotype.getNeuroDefs()) {
+			Neuro n = new Neuro();
+			n.copyFrom(nd);
+			model.neurons.add(n);
+		}
+
+		return model;
+	}
+}
Index: /java/main/src/main/java/com/framsticks/model/Genotype.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Genotype.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/model/Genotype.java	(revision 78)
@@ -2,10 +2,9 @@
 
 
-import com.framsticks.util.Containers;
+import org.apache.log4j.Logger;
 
-import java.util.ArrayList;
-import java.util.List;
+public class Genotype extends F0Genotype {
+	private final static Logger LOGGER = Logger.getLogger(Genotype.class);
 
-public class Genotype {
 	public String name;
 	public String genotype;
@@ -15,8 +14,4 @@
 	public Double getSimi() { return similarity; }
 	public void setSimi(Double simi) { similarity = simi; }
-
-	public Double startingEnergy;
-	public Double getEnerg0() { return startingEnergy; }
-	public void setEnerg0(Double energ0) { startingEnergy = energ0; }
 
 	public Double brainConnections;
@@ -40,5 +35,4 @@
 	public Double velocity;
 	public Double distance;
-
 
 	public Double verticalVelocity;
@@ -78,16 +72,4 @@
 	public String uid;
 
-	public final List<Part> parts = new ArrayList<Part>();
-	public final List<Joint> joints = new ArrayList<Joint>();
-	public final List<NeuroDef> neurodefs = new ArrayList<NeuroDef>();
+}
 
-
-    public Double getNumparts() { return (double)parts.size(); }
-	public Double getNumjoints() { return (double)joints.size(); }
-	public Double getNumneurons() { return (double)neurodefs.size(); }
-
-    //this is impossible to use, because numparts field is marked as readonly
-    public void setNumparts(Double numparts) { Containers.resizeList(parts, (int)(double)numparts); }
-    public void setNumjoints(Double numjoints) { Containers.resizeList(joints, (int)(double)numjoints); }
-    public void setNumneurons(Double numneurons) { Containers.resizeList(neurodefs, (int)(double)numneurons); }
-}
Index: /java/main/src/main/java/com/framsticks/model/Joint.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Joint.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/model/Joint.java	(revision 78)
@@ -8,69 +8,31 @@
  * All accessors are used by ReflectionAccess.
  */
-public class Joint {
+public class Joint extends BaseJoint {
 
+	/** i */
+	public String info;
+	public String getI() { return info; }
+	public void setI(String i) { info = i; }
+
+	/** p1 */
+	public Integer part1;
 	public void setP1(Integer p1) { part1 = p1; }
 	public Integer getP1() { return part1; }
+
+	/** p2 */
+	public Integer part2;
 	public void setP2(Integer p2) { part2 = p2; }
 	public Integer getP2() { return part2; }
 
-	public void setDx(Double dx) { delta.x = dx; }
-	public void setDy(Double dy) { delta.y = dy; }
-	public void setDz(Double dz) { delta.z = dz; }
 
-	public Double getDx() { return delta.x; }
-	public Double getDy() { return delta.y; }
-	public Double getDz() { return delta.z; }
-
-	public void setRx(Double rx) { rotation.x = rx; }
-	public void setRy(Double ry) { rotation.y = ry; }
-	public void setRz(Double rz) { rotation.z = rz; }
-
-	public Double getRx() { return rotation.x; }
-	public Double getRy() { return rotation.y; }
-	public Double getRz() { return rotation.z; }	
-
+	/** stam */
+	public Double stamina;
 	public Double getStam() { return stamina; }
 	public void setStam(Double stam) { stamina = stam; }
 
-	public Double getStif() { return stiffness; }
-	public void setStif(Double stif) { stiffness = stif; }
-
-	public Double getRotstif() { return rotationStiffness; }
-	public void setRotstif(Double rotstif) { rotationStiffness = rotstif; }
-
-	public String getI() { return info; }
-	public void setI(String i) { info = i; }
-
-	public String getVstyle() { return visualizationStyle; }
-	public void setVstyle(String Vstyle) { visualizationStyle = Vstyle; }
-
-	/** p1 */
-	public Integer part1;
-
-	/** p2 */
-	public Integer part2;
-
-	/** dx, dy, dz*/
-	public final Point3d delta = new Point3d();
-
-	/** rx, ry, rz*/
-	public final Point3d rotation = new Point3d();
-
-	/** stam */
-	public Double stamina;
-
-	/** stif */
-	public Double stiffness;
-
-	/** rotstif */
-	public Double rotationStiffness;
-
-	/** i */
-	public String info;
 
 	/** Vstyle */
 	public String visualizationStyle;
-
-
+	public String getVstyle() { return visualizationStyle; }
+	public void setVstyle(String Vstyle) { visualizationStyle = Vstyle; }
 }
Index: /java/main/src/main/java/com/framsticks/model/MechJoint.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/MechJoint.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/model/MechJoint.java	(revision 78)
@@ -6,52 +6,14 @@
  * @author Piotr Sniegowski
  */
-public class MechJoint {
-	/** rx, ry, rz*/
-	public final Point3d rotation = new Point3d();
-
-	/** dx, dy, dz*/
-	public final Point3d delta = new Point3d();
-
-	/** stif */
-	public Double stiffness;
-
-	/** rotstif */
-	public Double rotationStiffness;
+public class MechJoint extends BaseJoint {
 
 	/** stress */
 	public Double stress;
+	public Double getStress() { return stress; }
+	public void setStress(Double stress) { this.stress = stress; }
 
 	/** rotstress */
 	public Double rotationStress;
-
-	public Double getRx() { return rotation.x; }
-	public void setRx(Double rx) { rotation.x = rx; }
-
-	public Double getRy() { return rotation.y; }
-	public void setRy(Double ry) { rotation.y = ry; }
-
-	public Double getRz() { return rotation.z; }
-	public void setRz(Double rz) { rotation.z = rz; }
-
-	public Double getDx() { return delta.x; }
-	public void setDx(Double dx) { delta.x = dx; }
-
-	public Double getDy() { return delta.y; }
-	public void setDy(Double dy) { delta.y = dy; }
-
-	public Double getDz() { return delta.z; }
-	public void setDz(Double dz) { delta.z = dz; }
-
-	public Double getStif() { return stiffness; }
-	public void setStif(Double stif) { stiffness = stif; }
-
-	public Double getRotstif() { return rotationStiffness; }
-	public void setRotstif(Double rotstif) { rotationStiffness = rotstif; }
-
-	public Double getStress() { return stress; }
-	public void setStress(Double stress) { this.stress = stress; }
-
 	public Double getRotstress() { return rotationStress; }
 	public void setRotstress(Double rotstress) { rotationStress = rotstress; }
-
 }
Index: /java/main/src/main/java/com/framsticks/model/MechPart.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/MechPart.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/model/MechPart.java	(revision 78)
@@ -6,83 +6,32 @@
 /*
  */
-public class MechPart {
-
-	/** x, y, z */
-	public final Point3d position = new Point3d();
-
-	/** m */
-	public Double mass = 0.0;
-
-	/** s */
-	public Double size = 0.0;
+public class MechPart extends BasePart {
 
 	/** vol */
 	public Double volume = 0.0;
-
-	/** fr */
-	public Double friction = 0.0;
-
-	/** vx, vy, vz */
-	public final Point3d velocity = new Point3d();
-
-    /** oxx, oxy, oxz, oyx, oyy, oyz, ozx, ozy, ozz*/
-    public final Orientation orientation = new Orientation();
-
-	public Double getX() { return position.x; }
-	public void setX(Double x) { position.x = x; }
-
-	public Double getY() { return position.y; }
-	public void setY(Double y) { position.y = y; }
-
-	public Double getZ() { return position.z; }
-	public void setZ(Double z) { position.z = z; }
-
-	public Double getM() { return mass; }
-	public void setM(Double m) { mass = m; }
-
-	public Double getS() { return size; }
-	public void setS(Double s) { size = s; }
-
 	public Double getVol() { return volume; }
 	public void setVol(Double vol) { volume = vol; }
 
-	public Double getFr() { return friction; }
-	public void setFr(Double fr) { friction = fr; }
+	/** vx, vy, vz*/
+	public double vx, vy, vz;
 
-	public Double getVx() { return velocity.x; }
-	public void setVx(Double vx) { velocity.x = vx; }
+	public Point3d getVelocity() { return new Point3d(vx, vy, vz); }
+	public void setVelocity(Point3d v) { vx = v.x; vy = v.y; vz = v.z; }
 
-	public Double getVy() { return velocity.y; }
-	public void setVy(Double vy) { velocity.y = vy; }
+    public double oxx, oxy, oxz, oyx, oyy, oyz, ozx, ozy, ozz;
 
-	public Double getVz() { return velocity.z; }
-	public void setVz(Double vz) { velocity.z = vz; }
+	public Orientation getOrientation() { return new Orientation(new Point3d(oxx, oxy, oxz), new Point3d(oyx, oyy, oyz), new Point3d(ozx, ozy, ozz)); }
 
-	public Double getOxx() { return orientation.x.x; }
-	public void setOxx(Double oxx) { orientation.x.x = oxx; }
-
-	public Double getOxy() { return orientation.x.y; }
-	public void setOxy(Double oxy) { orientation.x.y = oxy; }
-
-	public Double getOxz() { return orientation.x.z; }
-	public void setOxz(Double oxz) { orientation.x.z = oxz; }
-
-	public Double getOyx() { return orientation.y.x; }
-	public void setOyx(Double oyx) { orientation.y.x = oyx; }
-
-	public Double getOyy() { return orientation.y.y; }
-	public void setOyy(Double oyy) { orientation.y.y = oyy; }
-
-	public Double getOyz() { return orientation.y.z; }
-	public void setOyz(Double oyz) { orientation.y.z = oyz; }
-
-	public Double getOzx() { return orientation.z.x; }
-	public void setOzx(Double ozx) { orientation.z.x = ozx; }
-
-	public Double getOzy() { return orientation.z.y; }
-	public void setOzy(Double ozy) { orientation.z.y = ozy; }
-
-	public Double getOzz() { return orientation.z.z; }
-	public void setOzz(Double ozz) { orientation.z.z = ozz; }
+	public void setOrientation(Orientation o) {
+		oxx = o.x.x;
+		oxy = o.x.y;
+		oxz = o.x.z;
+		oyx = o.y.x;
+		oyy = o.y.y;
+		oyz = o.y.z;
+		ozx = o.z.x;
+		ozy = o.z.y;
+		ozz = o.z.z;
+	}
 
 }
Index: /java/main/src/main/java/com/framsticks/model/Neuro.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Neuro.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/model/Neuro.java	(revision 78)
@@ -6,11 +6,7 @@
  * @author Piotr Sniegowski
  */
-public class Neuro {
+public class Neuro extends BaseNeuro {
 
 	public Integer channelCount;
-
-	public Integer inputCount;
-	public Integer getGetInputCount() { return inputCount; }
-	public void setGetInputCount(Integer getInputCount) { inputCount = getInputCount; }
 
 	public Double inputSum;
@@ -26,16 +22,8 @@
 	public Boolean hold;
 
+	public double position_x, position_y, position_z;
 
-	/** position_x, position_y, position_z*/
-	public final Point3d position = new Point3d();
-
-	public Double getPosition_x() { return position.x; }
-	public void setPosition_x(Double position_x) { position.x = position_x; }
-
-	public Double getPosition_y() { return position.y; }
-	public void setPosition_y(Double position_y) { position.y = position_y; }
-
-	public Double getPosition_z() { return position.z; }
-	public void setPosition_z(Double position_z) { position.z = position_z; }
+	public Point3d getPosition() { return new Point3d(position_x, position_y, position_z); }
+	public void setPosition(Point3d p) { position_x = p.x; position_y = p.y; position_z = p.z; }
 
 }
Index: /java/main/src/main/java/com/framsticks/model/NeuroDef.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/NeuroDef.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/model/NeuroDef.java	(revision 78)
@@ -4,5 +4,5 @@
  * @author Piotr Sniegowski
  */
-public class NeuroDef {
+public class NeuroDef extends BaseNeuro {
 
 	/** p */
@@ -21,7 +21,4 @@
 	public String visualizationStyle;
 
-	/** getInputCount */
-	public Integer inputCount;
-
 	public Integer getP() { return part; }
 	public void setP(Integer p) { part = p; }
@@ -39,6 +36,4 @@
 	public void setVstyle(String Vstyle) { visualizationStyle = Vstyle; }
 
-	public Integer getGetInputCount() { return inputCount; }
-	public void setGetInputCount(Integer getInputCount) { inputCount = getInputCount; }
 
 
Index: /java/main/src/main/java/com/framsticks/model/Package.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Package.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/model/Package.java	(revision 78)
@@ -0,0 +1,27 @@
+package com.framsticks.model;
+
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.Registry;
+import com.framsticks.util.Orientation;
+import com.framsticks.util.Point3d;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class Package {
+	public static void register(Registry registry) {
+		registry.registerReflectedClass("MechPart", null, "com.framsticks.model.MechPart");
+		registry.registerReflectedClass("Joint", "j", "com.framsticks.model.Joint");
+		registry.registerReflectedClass("MechJoint", null, "com.framsticks.model.MechJoint");
+		registry.registerReflectedClass("Neuro", null, "com.framsticks.model.Neuro");
+		registry.registerReflectedClass("NeuroDef", "n", "com.framsticks.model.NeuroDef");
+		registry.registerReflectedClass("Part", "p", "com.framsticks.model.Part");
+		registry.registerReflectedClass("Model", "m", "com.framsticks.model.F0Genotype");
+		registry.registerReflectedClass("F0Model", null, "com.framsticks.model.F0Model");
+		registry.registerReflectedClass("F0Genotype", null, "com.framsticks.model.F0Genotype");
+		registry.registerReflectedClass("Creature", null, "com.framsticks.model.Creature");
+		registry.registerReflectedClass("Genotype", null, "com.framsticks.model.Genotype");
+
+		registry.putInfoIntoCache(new FramsClass.Constructor(F0Model.class, "F0Model").getResult());
+	}
+}
Index: /java/main/src/main/java/com/framsticks/model/Part.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Part.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/model/Part.java	(revision 78)
@@ -7,23 +7,14 @@
  * The Class Part.
  */
-public class Part {
-
-	/** x, y, z*/
-	public final Point3d position = new Point3d();
+public class Part extends BasePart {
 
 	/** rx, ry, rz*/
-	public final Point3d rotation = new Point3d();
+	public double rx, ry, rz;
 
-	/** m */
-	public Double mass;
-
-	/** s */
-	public Double size;
+	public Point3d getRotation() { return new Point3d(rx, ry, rz); }
+	public void setRotation(Point3d r) { rx = r.x; ry = r.y; rz = r.z; }
 
 	/** dn */
 	public Double density;
-
-	/** fr */
-	public Double friction;
 
 	/** ing */
@@ -39,24 +30,7 @@
 	public String visualizationStyle;
 
-	public Double getX() { return position.x; }
-	public void setX(Double x) { position.x = x; }
-
-	public Double getY() { return position.y; }
-	public void setY(Double y) { position.y = y; }
-
-	public Double getZ() { return position.z; }
-	public void setZ(Double z) { position.z = z; }
-
-	public Double getM() { return mass; }
-	public void setM(Double m) { mass = m; }
-
-	public Double getS() { return size; }
-	public void setS(Double s) { size = s; }
-
 	public Double getDn() { return density; }
 	public void setDn(Double dn) { density = dn; }
 
-	public Double getFr() { return friction; }
-	public void setFr(Double fr) { friction = fr; }
 
 	public Double getIng() { return ingestion; }
@@ -65,13 +39,4 @@
 	public Double getAs() { return assimilation; }
 	public void setAs(Double as) { assimilation = as; }
-
-	public Double getRx() { return rotation.x; }
-	public void setRx(Double rx) { rotation.x = rx; }
-
-	public Double getRy() { return rotation.y; }
-	public void setRy(Double ry) { rotation.y = ry; }
-
-	public Double getRz() { return rotation.z; }
-	public void setRz(Double rz) { rotation.z = rz; }
 
 	public String getI() { return info; }
Index: /java/main/src/main/java/com/framsticks/observers/Observer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/observers/Observer.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/observers/Observer.java	(revision 78)
@@ -30,5 +30,5 @@
 
     @Override
-    protected void configure() {
+    protected void configure() throws Exception {
         super.configure();
         for (String name : config.getStringArray("endpoints")) {
@@ -38,5 +38,5 @@
             }
             Configuration c = config.subset("endpoints." + name);
-            Parameters p = new Parameters(c.subset("entity"), name, null);
+            Parameters p = new Parameters(c.subset("entity"), name, null, null);
             Entity e = Program.configureEntity(p);
             Instance i = Casting.tryCast(Instance.class, e);
Index: /java/main/src/main/java/com/framsticks/params/AccessInterface.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 78)
@@ -80,15 +80,4 @@
 
 	/**
-	 * Load values from single line String.
-	 * 
-	 * @param line
-	 *            the line with values
-	 * @return the list of not severe exceptions which occurred while loading
-	 * @throws Exception
-	 *             the severe exception occurred while loading
-	 */
-	List<Exception> load2(String line) throws Exception;
-
-	/**
 	 * Removes all the properties values.
 	 */
@@ -107,3 +96,4 @@
     FramsClass getFramsClass();
 
+
 }
Index: /java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 78)
@@ -73,9 +73,4 @@
 	}
 
-	@Override
-	public List<Exception> load2(String line) throws Exception {
-		return null;
-	}
-
 	public AccessInterface getElementAccess() {
 		return elementAccess;
Index: /java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Param.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/params/Param.java	(revision 78)
@@ -109,5 +109,5 @@
         } catch (ClassCastException e) {
             throw new ClassCastException("property \"" + name
-                    + "\" getType is \"" + value.getClass().getName()
+                    + "\" type is \"" + value.getClass().getName()
                     + "\", not \"" + type.getName() + "\"");
         }
Index: /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 78)
@@ -20,7 +20,10 @@
     @Override
 	public Map<String, Object> createAccessee() {
+		return PropertiesAccess.createPropertiesMap();
+	}
+
+	public static Map<String, Object> createPropertiesMap() {
 		return new HashMap<String, Object>();
 	}
-
 
 	public PropertiesAccess(FramsClass framsClass) {
@@ -83,5 +86,3 @@
 
 
-
-
 }
Index: /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 78)
@@ -3,4 +3,6 @@
 import java.lang.reflect.Field;
 import java.lang.reflect.InvocationTargetException;
+import java.lang.reflect.Modifier;
+import java.lang.reflect.Type;
 import java.util.List;
 
@@ -43,9 +45,9 @@
 			String id = param.getId();
 			try {
-				return type.cast(object.getClass().getField(id).get(object));
+				return type.cast(reflectedClass.getField(id).get(object));
 			} catch (NoSuchFieldException ignored) {
 			}
 			try {
-				return type.cast(object.getClass().getMethod(accessorName(true, id)).invoke(object));
+				return type.cast(reflectedClass.getMethod(accessorName(true, id)).invoke(object));
 			} catch (NoSuchMethodException ex) {
 				//ex.printStackTrace();
@@ -68,5 +70,5 @@
 	}
 
-	private <T> void setValue(Param param, T val) {
+	private <T> void setValue(Param param, T value) {
 		if (object == null) {
 			return;
@@ -75,16 +77,21 @@
 			String id = param.getId();
 			try {
-				object.getClass().getField(id).set(object, val);
+				Field f = reflectedClass.getField(id);
+				Class t = f.getType();
+				if (Modifier.isFinal(f.getModifiers())) {
+					return;
+				}
+				if (value != null || (!t.isPrimitive())) {
+					f.set(object, value);
+				}
 				return;
 			} catch (NoSuchFieldException ignored) {
 			}
 			try {
-				object.getClass().getMethod(accessorName(false, id), new Class[]{val.getClass()}).invoke(object, val);
-			} catch (InvocationTargetException e) {
-				//e.printStackTrace();
+				reflectedClass.getMethod(accessorName(false, id), new Class[]{param.getStorageType()}).invoke(object, value);
+			} catch (InvocationTargetException ignored) {
 			} catch (NoSuchMethodException ignored) {
 			}
-		} catch (IllegalAccessException ex) {
-			LOGGER.warn("illegal access error occurred while trying to access returnedObject");
+		} catch (Exception ex) {
 			ex.printStackTrace();
 		}
@@ -103,14 +110,9 @@
 		resetErrors();
 
-		Field[] fields;
 		try {
-			// TODO: conceptually invalid - should clean only fields that are specified in FramsClass
-			fields = object.getClass().getFields();
-
-			for (Field field : fields) {
-				field.set(object, null);
+			for (Param p : framsClass.getParamEntries()) {
+				setValue(p, p.getDef(Object.class));
 			}
-		} catch (IllegalAccessException ex) {
-			LOGGER.warn("IllegalAccessException thrown while trying to reset object values");
+		} catch (IllegalArgumentException ex) {
 			ex.printStackTrace();
 		}
@@ -125,4 +127,5 @@
 	@Override
 	public void select(Object object) {
+		assert object == null || reflectedClass.isInstance(object);
 		this.object = object;
 	}
@@ -166,5 +169,4 @@
         }
         LOGGER.fatal("failed to create reflected object of class " + reflectedClass.getCanonicalName() + " for frams type " + framsClass.getId());
-
         return null;
     }
Index: /java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 78)
@@ -0,0 +1,65 @@
+package com.framsticks.params;
+
+import org.apache.log4j.Logger;
+
+import java.util.HashMap;
+import java.util.Map;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class Registry {
+	private static final Logger LOGGER = Logger.getLogger(Registry.class.getName());
+
+	protected final Map<String, Class> reflectedClasses = new HashMap<String, Class>();
+	protected final Map<String, String> invertedReflectedClasses = new HashMap<String, String>();
+	protected final Map<String, FramsClass> infoCache = new HashMap<String, FramsClass>();
+
+	public final void registerReflectedClass(String name, String id, String className) {
+		try {
+			registerReflectedClass(name, id, Class.forName(className));
+		} catch (ClassNotFoundException e) {
+			LOGGER.fatal("class not found during registration: " + e);
+		}
+	}
+
+	public void registerReflectedClass(String name, String id, Class reflectedClass) {
+		if (name != null) {
+			reflectedClasses.put(name, reflectedClass);
+			invertedReflectedClasses.put(reflectedClass.getCanonicalName(), name);
+		}
+		if (id != null) {
+			reflectedClasses.put(id, reflectedClass);
+		}
+	}
+
+	public AccessInterface createAccess(String name, FramsClass framsClass) {
+		if (reflectedClasses.containsKey(name)) {
+			return new ReflectionAccess(reflectedClasses.get(name), framsClass);
+		}
+		return new PropertiesAccess(framsClass);
+	}
+
+	public void putInfoIntoCache(FramsClass framsClass) {
+		if (infoCache.containsKey(framsClass.getId())) {
+			LOGGER.info("already cached " + framsClass);
+			return;
+		}
+		LOGGER.debug("caching info for " + framsClass);
+		infoCache.put(framsClass.getId(), framsClass);
+		infoCache.put(framsClass.getName(), framsClass);
+	}
+
+	public FramsClass getInfoFromCache(String id) {
+		if (id == null) {
+			return null;
+		}
+		if (infoCache.containsKey(id)) {
+			return infoCache.get(id);
+		}
+		if (invertedReflectedClasses.containsKey(id)) {
+			return getInfoFromCache(invertedReflectedClasses.get(id));
+		}
+		return null;
+	}
+}
